<html><head><title>Homework: Logging</title> <link rel="stylesheet" href="homework.css" type="text/css" /></head><body><h1>Homework: Logging</h1>Read: log.c.<h2>Hand-In Procedure</h2>Please write up your answers to the exercise below and hand them in to a 6.828 staff member at the beginning of lecture.<h2>Writing with a Log</h2>Insert a print statement in bwrite (in bio.c) so that you get a print every time a block is written to disk:<pre>
  cprintf("bwrite sector %d\n", b->sector);
</pre>Build and boot a new kernel and run this:<pre>
  $ rm README
</pre><p>You should see a sequence of bwrite prints after the <tt>rm</tt>.</p><div class="question"><p><b>Submit</b>:<ol><li>The bwrite lines, each annotated with the kind of information that is being written to the disk (e.g., "README's inode", "allocation bitmap"). If the log is being written, note both that the log is being written and also what kind of information is being written to the log. <li>Mark with an arrow the first point at which, if a crash occured, README would be missing after a reboot (after the call to <tt>recover_from_log()</tt>).</ol></p></div></body>